var _ = require('underscore');
var fs = require('fs');
var express = require("express");
var http = require('http');
var io = require('socket.io');
var monome = require('monome');
var api = require('./lib/api');
var socket = require('./lib/socket');

var app = express();
app.configure(function() {
  app.use(express.bodyParser());
  app.use(app.router);
  // serve up static file if found
  app.use('/', express.static(__dirname + '/public'));
  // serve up api routes next
  api.create(app);
  // everything else gets index.html
  // app.use('/', function (req, res, next) {
  //   fs.readFile(__dirname + '/public/index.html', 'utf8', function (err, data) {
  //     res.end(data);
  //   });
  // });
});

var server = http.createServer(app);
socket.listen(server, {log: true});
server.listen(8001);

monome.discover();