var blocks = require('../../../blocks');

exports.create = function(req, res) {
  req.body = fixBody(req.body);
  var newBlock = blocks.running.create(req.body);
  if (!newBlock) {
    res.statusCode = 404;
    res.end('Not found');
    return;
  }
  res.json(newBlock);
};

exports.update = function(req, res) {
  req.body = fixBody(req.body);
  req.params.id = parseInt(req.params.id, 10);
  var result = blocks.running.update(req.params.id, req.body);
  if (!result) {
    res.statusCode = 404;
    res.end('Not found');
    return;
  }
  res.json(result);
};

exports.findAll = function(req, res) {
  res.json(blocks.running.findAll());
};

var fixBody = function(body) {
  if (body.id) body.id = parseInt(body.id, 10);
  if (body.sizeX) body.sizeX = parseInt(body.sizeX, 10);
  if (body.sizeY) body.sizeY = parseInt(body.sizeY, 10);
  if (body.offsetX) body.offsetX = parseInt(body.offsetX, 10);
  if (body.offsetY) body.offsetY = parseInt(body.offsetY, 10);
  return body;
};