var _ = require('underscore');
var emulators = require('../../../emulators');

var fields = ['id', 'serialoscId', 'prefix', 'name', 'midiIn', 'midiOut'];

exports.findById = function (req, res) {
  req.params.id = parseInt(req.params.id, 10);
  var emulator = emulators.running.findById(req.params.id);
  if (!emulator) {
    res.statusCode = 404;
    res.end();
    return;
  }
  res.json(_.pick(emulator, fields));
};

exports.findAll = function (req, res) {
  var out = [];
  _.each(emulators.running.findAll(), function (emulator) {
    out.push(_.pick(emulator, fields));
  });
  res.json(out);
};

exports.create = function (req, res) {
  req.body.moduleId = parseInt(req.body.moduleId, 10);
  var newEmulator = emulators.running.create(req.body.moduleId, req.body);
  if (!newEmulator) {
    res.statusCode = 404;
    res.end();
    return;
  }
  res.json(_.pick(newEmulator, fields));
};

exports.destroy = function (req, res) {
  req.params.id = parseInt(req.params.id, 10);
  var emulator = emulators.running.destroy(req.params.id);
  if (!emulator) {
    res.statusCode = 404;
    res.end();
    return;
  }
  res.json(_.pick(emulator, fields));
};