var midi = require('midi');

var input = new midi.input();
var output = new midi.output();

exports.ins = {
  findAll: function () {
    var ins = [];
    try {
      for (var i = 0; i < input.getPortCount(); i++) {
        ins.push({id: i+1, name: input.getPortName(i)});
      }
    } catch(error) {
      console.log("[midi in error] " + error);
      return false;
    }
    return ins;
  },
  findById: function (id) {
    var ins = this.findAll();
    if (!ins) {
      return false;
    }
    var inp = _.where(ins, {id: id}).pop();
    return inp || false;
  }
};

exports.outs = {
  findAll: function () {
    var outs = [];
    try {
      for (var i = 0; i < output.getPortCount(); i++) {
        outs.push({id: i+1, name: output.getPortName(i)});
      }
    } catch(error) {
      console.log("[midi out error] " + error);
      return false;
    }
    return outs;
  },
  findById: function (id) {
    var outs = this.findAll();
    if (!outs) {
      return false;
    }
    var out = _.where(outs, {id: id}).pop();
    return out || false;
  }
};