var _ = require('underscore');
var socketio = require('socket.io');
var monome = require('monome');

var sockets = [];
var io;

exports.listen = function (server, options) {
  io = socketio.listen(server, options);
  io.sockets.on('connection', function(socket) {
    sockets.push(socket);
    socket.on('disconnect', function() {
      sockets = _.without(sockets, socket);
    });
  });
  var that = this;
  monome.on('deviceFound', function(device) {
    console.log("found device " + device.service.name);
    that.broadcast('updateDevices');
    that.broadcast('msg', 'found ' + device.service.name);
  });
  monome.on('deviceLost', function(device) {
    console.log("lost device " + device.service.name);
    that.broadcast('updateDevices');
    that.broadcast('msg', 'lost ' + device.service.name);
  });
};

exports.broadcast = function broadcast (msg, data) {
  _.each(sockets, function (socket) {
    socket.emit(msg, data);
  });
};